'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _Bar = require('./Bar');

var _Bar2 = _interopRequireDefault(_Bar);

var _emptyFunction = require('./utils/emptyFunction');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var enhance = (0, _recompose.compose)(_recompose.pure, (0, _recompose.setPropTypes)({
  yScale: _react.PropTypes.func,
  xScale: _react.PropTypes.func,
  getBarProps: _react.PropTypes.func,
  data: _react.PropTypes.arrayOf(_react.PropTypes.shape({
    x: _react.PropTypes.any,
    y: _react.PropTypes.any
  }))
}));

var BarChart = function BarChart(_ref) {
  var _ref$data = _ref.data,
      data = _ref$data === undefined ? [] : _ref$data,
      xScale = _ref.xScale,
      yScale = _ref.yScale,
      _ref$getBarProps = _ref.getBarProps,
      getBarProps = _ref$getBarProps === undefined ? _emptyFunction2.default : _ref$getBarProps,
      otherProps = _objectWithoutProperties(_ref, ['data', 'xScale', 'yScale', 'getBarProps']);

  var yBasis = yScale(0);

  return _react2.default.createElement(
    'g',
    otherProps,
    data.map(function (datum, index) {
      var x = datum.x,
          y = datum.y,
          _datum$props = datum.props,
          props = _datum$props === undefined ? {} : _datum$props;

      var scaledX = xScale(x);
      var scaledY = yScale(y);

      return (0, _react.createElement)(_Bar2.default, _extends({
        key: scaledX + ', ' + scaledY,
        x1: scaledX,
        x2: scaledX,
        y1: yBasis,
        y2: scaledY
      }, getBarProps(datum, index), props));
    })
  );
};

exports.default = enhance(BarChart);