'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _createPath = require('./utils/createPath');

var _createPath2 = _interopRequireDefault(_createPath);

var _emptyFunction = require('./utils/emptyFunction');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

var _Dot = require('./Dot');

var _Dot2 = _interopRequireDefault(_Dot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var isFunction = function isFunction(fn) {
  return typeof fn === 'function';
};

var enhance = (0, _recompose.compose)(_recompose.pure, (0, _recompose.setPropTypes)({
  generator: _react.PropTypes.func,
  getDotProps: _react.PropTypes.func,
  getLineProps: _react.PropTypes.func,
  data: _react.PropTypes.array,

  // deprecated
  yScale: _react.PropTypes.func,
  xScale: _react.PropTypes.func
}));

var LineChart = function LineChart(_ref) {
  var _ref$data = _ref.data,
      rawData = _ref$data === undefined ? [] : _ref$data,
      generator = _ref.generator,
      xScale = _ref.xScale,
      yScale = _ref.yScale,
      getDotProps = _ref.getDotProps,
      _ref$getLineProps = _ref.getLineProps,
      getLineProps = _ref$getLineProps === undefined ? _emptyFunction2.default : _ref$getLineProps,
      otherProps = _objectWithoutProperties(_ref, ['data', 'generator', 'xScale', 'yScale', 'getDotProps', 'getLineProps']);

  var path = isFunction(generator) ? generator(rawData) : (0, _createPath2.default)(rawData.map(_ramda2.default.evolve({ x: xScale, y: yScale })));

  return _react2.default.createElement(
    'g',
    otherProps,
    _react2.default.createElement('path', _extends({
      d: path,
      stroke: '#EFEFEF',
      strokeWidth: '2',
      fill: 'transparent'
    }, getLineProps())),
    getDotProps && rawData.map(function (datum, index) {
      var _R$evolve = _ramda2.default.evolve({ x: xScale, y: yScale }, datum),
          x = _R$evolve.x,
          y = _R$evolve.y;

      return _react2.default.createElement(_Dot2.default, _extends({
        key: x + ', ' + y,
        x: x,
        y: y,
        r: 3,
        color: '#EFEFEF'
      }, getDotProps(datum, index)));
    })
  );
};

exports.default = enhance(LineChart);