'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _translate = require('./utils/translate');

var _Dot = require('./Dot');

var _Dot2 = _interopRequireDefault(_Dot);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var enhance = (0, _recompose.compose)((0, _recompose.getContext)({
  yScale: _react.PropTypes.func,
  xScale: _react.PropTypes.func
}), _recompose.pure);

var ScatterPlot = function ScatterPlot(_ref) {
  var xScale = _ref.xScale,
      yScale = _ref.yScale,
      data = _ref.data,
      _ref$dotComponent = _ref.dotComponent,
      DotComponent = _ref$dotComponent === undefined ? _Dot2.default : _ref$dotComponent;
  return _react2.default.createElement(
    'g',
    null,
    data.map(function (d) {
      return _react2.default.createElement(
        'g',
        {
          key: d.key,
          transform: (0, _translate.translate)(xScale(d.x), yScale(d.y))
        },
        _react2.default.createElement(DotComponent, d)
      );
    })
  );
};

exports.default = enhance(ScatterPlot);