'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _Line = require('./Line');

var _Line2 = _interopRequireDefault(_Line);

var _transformAxis = require('./utils/transformAxis');

var _transformAxis2 = _interopRequireDefault(_transformAxis);

var _getLineCoordinate = require('./utils/getLineCoordinate');

var _getLineCoordinate2 = _interopRequireDefault(_getLineCoordinate);

var _translate = require('./utils/translate');

var _emptyFunction = require('./utils/emptyFunction');

var _emptyFunction2 = _interopRequireDefault(_emptyFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var enhance = (0, _recompose.compose)((0, _recompose.setPropTypes)({
  axis: _react.PropTypes.oneOf(['x', 'y']),
  tickSize: _react.PropTypes.number,
  values: _react.PropTypes.array,
  scale: _react.PropTypes.func,
  getTickProps: _react.PropTypes.func
}), _recompose.pure);

var Ticks = function Ticks(_ref) {
  var tickSize = _ref.tickSize,
      _ref$axis = _ref.axis,
      axis = _ref$axis === undefined ? 'x' : _ref$axis,
      _ref$values = _ref.values,
      values = _ref$values === undefined ? [] : _ref$values,
      scale = _ref.scale,
      _ref$getTickProps = _ref.getTickProps,
      getTickProps = _ref$getTickProps === undefined ? _emptyFunction2.default : _ref$getTickProps,
      otherProps = _objectWithoutProperties(_ref, ['tickSize', 'axis', 'values', 'scale', 'getTickProps']);

  return _react2.default.createElement(
    'g',
    otherProps,
    values.map(function (value, index) {
      return (0, _react.createElement)(_Line2.default, _extends({
        key: value,
        transform: axis === 'x' ? (0, _translate.translateX)(scale(value)) : (0, _translate.translateY)(scale(value))
      }, getTickProps(value, index), (0, _getLineCoordinate2.default)((0, _transformAxis2.default)(axis), 0, tickSize)));
    })
  );
};

exports.default = enhance(Ticks);